diff --git a/doc/guix.texi b/doc/guix.texi
index 5a597cf122..ba80b9660c 100644
--- a/doc/guix.texi
+++ b/doc/guix.texi
@@ -19383,6 +19383,10 @@ Scheduled Job Execution
 This is a list of symbols naming Shepherd services that this service
 will depend on.
 
+@item @code{instance} (type: maybe-symbol)
+Set the shepherd service name to @code{mcron-@var{instance}}.  This is
+useful when you want to have more than one mcron instance.
+
 @item @code{jobs} (default: @code{()}) (type: list-of-gexps)
 This is a list of gexps (@pxref{G-Expressions}), where each gexp
 corresponds to an mcron job specification (@pxref{Syntax, mcron job
@@ -19392,7 +19396,9 @@ Scheduled Job Execution
 Log messages to standard output.
 
 @item @code{log-file} (default: @code{"/var/log/mcron.log"}) (type: string)
-Log file location.
+Log file location.  When @var{instance} is set and @var{log-file} is
+kept at its @emph{default value}, it will log to
+@file{/var/log/mcron-@var{instance}.log}.
 
 @item @code{log-format} (default: @code{"~1@@*~a ~a: ~a~%"}) (type: string)
 @code{(ice-9 format)} format string for log messages.  The default value
@@ -19407,6 +19413,28 @@ Scheduled Job Execution
 @end deftp
 @c %end of fragment
 
+Occasionally, it is desirable to run another mcron instance to separate
+some of the jobs from the main mcron instance for clarity purposes, or if
+the jobs are very chatty and frequent. (for example, a heartbeat check
+every 30 seconds)
+
+The example below shows how an extra mcron service can be defined.
+@lisp
+(use (guix)
+     (guix records)
+     (gnu services)
+     (gnu services mcron))
+
+(define secondary-mcron-service-type
+  (service-type
+   (inherit mcron-service-type)
+   (name 'mcron-secondary)
+   (default-value
+     (mcron-configuration
+       (instance 'secondary)
+       (log-file "/var/log/mcron-secondary.log")))))
+@end lisp
+
 @node Log Rotation
 @subsection Log Rotation
 
diff --git a/gnu/services/mcron.scm b/gnu/services/mcron.scm
index 99eb0edd60..4d8ab4af2c 100644
--- a/gnu/services/mcron.scm
+++ b/gnu/services/mcron.scm
@@ -27,12 +27,14 @@ (define-module (gnu services mcron)
   #:use-module (guix records)
   #:use-module (guix gexp)
   #:use-module (srfi srfi-1)
+  #:use-module (ice-9 format)
   #:use-module (ice-9 match)
   #:use-module (ice-9 vlist)
   #:export (mcron-configuration
             mcron-configuration?
             mcron-configuration-mcron
             mcron-configuration-shepherd-requirement
+            mcron-configuration-instance
             mcron-configuration-jobs
             mcron-configuration-log?
             mcron-configuration-log-file
@@ -63,6 +65,7 @@ (define list-of-symbols?
   (list-of symbol?))
 
 (define-maybe/no-serialization string)
+(define-maybe/no-serialization symbol)
 
 (define-configuration/no-serialization mcron-configuration
   (mcron
@@ -74,6 +77,11 @@ (define-configuration/no-serialization mcron-configuration
    "This is a list of symbols naming Shepherd services that this service
 will depend on.")
 
+  (instance
+   maybe-symbol
+   "Set the shepherd service name to @code{mcron-@var{instance}}.
+This is useful when you want to have more than one mcron instance.")
+
   (jobs
    (list-of-gexps '())
    "This is a list of gexps (@pxref{G-Expressions}), where each gexp
@@ -86,7 +94,9 @@ (define-configuration/no-serialization mcron-configuration
 
   (log-file
    (string "/var/log/mcron.log")
-   "Log file location.")
+   "Log file location.  When @var{instance} is set and @var{log-file}
+is kept at its @emph{default value}, it will log to
+@file{/var/log/mcron-@var{instance}.log}.")
 
   (log-format
    (string "~1@*~a ~a: ~a~%")
@@ -167,12 +177,26 @@ (define (shepherd-schedule-action mcron files)
 
 (define (mcron-shepherd-services config)
   (match-record config <mcron-configuration>
-    (mcron shepherd-requirement jobs log? log-file log-format date-format)
+    (mcron shepherd-requirement instance
+     jobs log? log-file log-format date-format)
     (if (eq? jobs '())
         '()                             ;nothing to do
-        (let ((files (job-files mcron jobs)))
+        (let* ((files (job-files mcron jobs))
+               (instance-name
+                (format #f "mcron~@[-~a~]" (maybe-value instance)))
+               (service-name (string->symbol instance-name))
+               ;; Make log-file robust against multiple instances
+               ;; attempting to write to the same file when
+               ;; left at its default value.
+               (default-log-file (mcron-configuration-log-file
+                                       (mcron-configuration)))
+               (log-file* (if (and (maybe-value-set? instance)
+                                   (equal? log-file default-log-file))
+                              (string-append (dirname default-log-file)
+                                             "/" instance-name ".log")
+                              log-file)))
           (list (shepherd-service
-                 (provision '(mcron))
+                 (provision (list service-name))
                  (requirement `(user-processes ,@shepherd-requirement))
                  (modules `((srfi srfi-1)
                             (srfi srfi-26)
@@ -199,7 +223,7 @@ (define (mcron-shepherd-services config)
                                   (remove (cut string-prefix? "PATH=" <>)
                                           (environ)))
 
-                           #:log-file #$log-file))
+                           #:log-file #$log-file*))
                  (stop #~(make-kill-destructor))
                  (actions
                   (list (shepherd-schedule-action mcron files)))))))))